package
{
	import org.flixel.FlxG;

	public class GameManager
	{
		
		public var map:Vector.<Vector.<String>>;
		public function GameManager(fill:Boolean=false)
		{
			map = new Vector.<Vector.<String>>();
			if (fill)
				FillBlank();
		}
		
		public function FillBlank():void
		{
			map = new Vector.<Vector.<String>>();
			for (var i:int=0;i<FlxG.width/8;i++)
			{
				var row:Vector.<String> = new Vector.<String>();
				for (var j:int=0;j<FlxG.height/8;j++)
				{
					row.push(" ");
				}
				map.push(row);
			}
		}
		
		
		public function PrintSprite(spritemanager:GridSprite):void
		{
			var px:int=spritemanager.posx;
			var py:int=spritemanager.posy;
			if (spritemanager is Target)
			{
				switch (map[py][px])
				{					
					case " ":
						map[py][px]=".";
						break;	
					case ".":
						trace("ERROR1");
						break;		
					case "@":
						map[py][px]="+";
						break;		
					case "$":
						map[py][px]="*";
						break;
					default:
						trace("ERROR2"+map[py][px]);
						break;
				}
			}
			else if (spritemanager is Player)
			{
				switch (map[py][px])
				{					
					case " ":
						map[py][px]="@";
						break;	
					case ".":
						map[py][px]="+";
						break;		
					default:
						trace("ERROR3"+map[py][px]);
						break;
				}
				
			}
			else if (spritemanager is Block)
			{
				switch (map[py][px])
				{					
					case " ":
						map[py][px]="$";
						break;	
					case ".":
						map[py][px]="*";
						break;		
					default:
						trace("ERROR4"+map[py][px]);
						break;
				}				
			}
		}
		
		public function Serialize():String
		{
			var result:String = "";
			for (var i:int=0;i<map.length;i++)
			{
				if (i>0)
					result+="\n";
				for (var j:int=0;j<map[i].length;j++)
				{
					result+=map[i][j];
				}
			}
			return result;
		}
		
	}
}