package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	
	import org.flixel.FlxCamera;
	import org.flixel.FlxG;
	import org.flixel.FlxObject;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	
	public class Player extends GridSprite
	{
		public function Player(tilePosX:int,tilePosY:int,tilesize:int,Graphic:Class,parent:GameState)
		{
			super(tilePosX,tilePosY,tilesize,Graphic,parent);
			this.loadGraphic(GameState.ImgPlayer,true,true,8,8);
			//this.width=6;
			//this.height=6;
			//this.offset.x=1;
			//this.offset.y=1;
			this.addAnimation("idle",[0,1],7);
			//this.addAnimation("jump",[1],2);
			this.play("idle");	
			this.solid=true;
			this.maxVelocity.x=80;
			this.maxVelocity.y=80;
			this.drag = new FlxPoint(400,400);
			pushed=false;
		//	this.acceleration.y=300;
		}
		
		override public function update():void
		{			
			if (_parent.Ready()==false)
			{
				super.update();
				return;
			}
			
			var dir:int=-1;
			
			if (levelending==false)
			{
				if (FlxG.keys.justPressed("R"))
				{
					TweenMax.killAll();
					FlxG.switchState(new GameState());
				}
				if (FlxG.keys.LEFT)
				{
					dir=FlxObject.LEFT;
				}
				if (FlxG.keys.RIGHT)
				{	
					dir=FlxObject.RIGHT;
				}
				if (FlxG.keys.UP)
				{
					dir=FlxObject.UP;
				}
				if (FlxG.keys.DOWN)
				{
					dir=FlxObject.DOWN;
				}				
			
				pushed=false;
				if (dir>=0)
				{
					if (CanPush(dir))
					{
						Push(dir);
						
						checkwin();
					}
				}
				
				
				if (pushed)
				{
					FlxG.play(GameState.SndBlock);
					pushed=false;
				}
				
			}
			
			super.update();
		}
		
		public static var pushed:Boolean=false;
		private function checkwin():void
		{
			var cameras:Vector.<GridSprite> = _parent.camerasprites;
			var exits:Vector.<GridSprite> = _parent.exitsprites;
			for (var i:int=0;i<cameras.length;i++)
			{
				var cam:GridSprite = cameras[i];
				var found:Boolean=false;
				for (var j:int=0;j<exits.length;j++)
				{
					var exit:GridSprite = exits[j];
					if (exit.posx==cam.posx && exit.posy==cam.posy)
					{
						found=true;
						break;
					}					
				}
				if (found==false)
				{
					return;
				}
			}
			
			//all found, next level
			if (found)
			{
				NewLevel();
			}
		}
		
		public static var LevelCount:int=6;
		
		public static var levelending:Boolean=false;
		
		private function NewLevel():void
		{
			if (levelending==true)
				return;
			FlxG.level++;
			levelending=true;
			FlxG.flash(0xffffffff,1,SwitchLevel,true);
			FlxG.play(GameState.SndCamera);
		}
		
		private function SwitchLevel():void
		{
			TweenMax.killAll();
			if (FlxG.level<LevelCount)
			{
				FlxG.switchState(new GameState());
			}
			else
			{
				FlxG.switchState(new EndState());
			}		
		}
		
	}
	
}