package
{
	import org.flixel.*;

	public class TitleState extends FlxState
	{
		


		//segAB and segCD demand conditions:  That the intersection point belong to line segment A, B, both, or neither.
		public static function intersect(A:FlxPoint, B:FlxPoint, C:FlxPoint, D:FlxPoint, segAB:Boolean = true, segCD:Boolean = true):FlxPoint
		{			
			var I:FlxPoint = null;
			
			//First make sure the lines are even anywhere near eachother.
			if (A.y < C.y && A.y < D.y && B.y < C.y && B.y < D.y) return I;
			if (A.y > C.y && A.y > D.y && B.y > C.y && B.y > D.y) return I;
			if (A.x < C.x && A.x < D.x && B.x < C.x && B.x < D.x) return I;
			if (A.x > C.x && A.x > D.x && B.x > C.x && B.x > D.x) return I;
			
			var uABCD:Number = (D.y - C.y) * (B.x - A.x) - (D.x - C.x)*(B.y - A.y);	//Find denominator first.
			if (uABCD == 0) return I;
			
			var uAB:Number = (D.x - C.x)*(A.y - C.y) - (D.y - C.y)*(A.x - C.x);
			uAB /= uABCD;
			var uCD:Number = (B.x - A.x) * (A.y - C.y) - (B.y - A.y) * (A.x - C.x);
			uCD /= uABCD;
			if (segAB && (uAB < 0 || uAB > 1)) return I; 
			if (segCD && (uCD < 0 || uCD > 1)) return I;	// The intersection is beyond the line segments' end points.
			
			I = new FlxPoint(A.x + uAB * (B.x - A.x), A.y + uAB * (B.y - A.y));
			
			return I;
		}
		
		
		override public function create():void
		{
			super.create();
			FlxG.playMusic(GameState.SndMusic);
			trace("created");
			FlxG.level=0;
			//FlxG.playMusic(GameState.SndMusic);
			
			var title:FlxText = new FlxText(0,0,FlxG.width,"Travelling");
			title.size=8;
			title.alignment="center";		
			title.color=0xffffffff;
			add(title); //adds a 100px wide text field at position 0,0 (upper left)
			var subtitle:FlxText = new FlxText(0,FlxG.height/2,FlxG.width,"click to start");
			subtitle.alignment="center";
			subtitle.color=0xffffffff;
			subtitle.size=8;
			FlxG.level=0;
								
			add(subtitle);
		}
		
		override public function update():void
		{
			if (FlxG.mouse.justPressed())
			{
				FlxG.switchState(new GameState());
			}
			super.update();
		}
	}
}